\chapter{The \texttt{cryptsetup} utility}

We have chosen `cryptsetup` \cite{cryptsetup} as the program under test. It is a full disk encryption (FDE) utility used on many popular Linux distributions, which creates and configures encrypted block devices using a `dm-crypt` kernel module \cite{dm-crypt}. The `dm-crypt` module initiates a virtual device that provides plaintext access to the underlying encrypted device. The mapping is transparent, and applications can use the plaintext device as normal storage. Any read from the plaintext device will cause read and decryption from the underlying encrypted device. Writing to the plaintext device causes encryption of the written data and storing the generated ciphertext on the underlying device \cite{Broz2019thesis}. The advantage of FDE is that it operates on the lowest level of the storage stack and encrypts the whole device. Therefore, it allows using any filesystem on top of the virtual device without any changes.

The `dm-crypt` kernel module only allows directly specifying the encryption algorithm, mode, initialization vector and encryption key. The user must specify all the parameters and keys every time he tries to activate the encrypted volume. After creating the decryption mapping, there is no check that the used key was correct (apart from, e.g. checking magic values during filesystem mounting). If the user supplies a wrong decryption key, he can accidentally overwrite a part of the volume under the wrong key leading to data corruption. Changing the volume key requires re-encrypting the whole drive using the new key. Such an approach is error-prone and discouraged.

# Linux Unified Key Setup

Linux Unified Key Setup (LUKS) was proposed and implemented by Clemens Fruhwirth \cite{LUKS_phd}. The format introduced a binary header that contains metadata about the used cipher and mode. It also introduced key encrypting keys (KEK) called keyslots. To unlock the keyslot using a passphrase, a KEK is derived from it using a key derivation function (KDF). A user can create multiple keyslots which wrap the same volume key. It is easy to add, remove or change passphrases without re-encrypting the whole disk. After introducing LUKS support in `cryptsetup`, it became widely popular and used in all major Linux distributions \cite{Broz2019thesis}.

As time went by, shortcomings of the original LUKS format became apparent. Damaging the header is especially dangerous because there is no redundant copy. Losing access to the header means losing the keyslots and consequently the wrapped volume key, leading to the loss of encrypted data. The header is entirely stored in the first sector of the device, which is also used by other formats that store magic values and metadata there. Therefore other utilities or operating systems can accidentally overwrite or damage the LUKS header.

The original LUKS format was not designed to be extended in the future. Some parameters are fixed and cannot be specified in the header, like the used KDF and digest size (20 bytes based on the now deprecated SHA1 function). Not only no new algorithms can be added, but due to the rigid structure of the LUKS format, it is hard to adapt it for use cases that emerged later, like authenticated encryption or re-encryption support \cite{Broz2019thesis}.

To solve these issues, a new file format LUKS2 was devised by Milan Brož \cite{Broz2019thesis}. To make the format future-proof, it had to be made algorithm-independent and use a generic and extensible metadata format. For this reason, JSON \cite{json} format was chosen for metadata storage in addition to the binary header. This way, developers can add new cipher support or extend the format without changing the structure of the binary header.

In LUKS2, the header is stored in two copies except for keyslots as they are intended to be removed securely and keeping multiple copies could increase the chances of a compromise. The binary header now contains a checksum of itself to detect unintentional header modification or corruption. If one of the headers is corrupted, the `cryptsetup` utility will start automatic repair using the other header. The user can convert the older LUKS header to the new LUKS2 format in place.

The LUKS2 format introduced the concept of _tokens_ which are external applications for obtaining passphrases (e.g. using a hardware token or from a remote server) that can store additional application-specific metadata in the header \cite{Broz2019thesis}. LUKS2 metadata format became the default for newly formatted devices since `cryptsetup` version 2.1.0 \cite{cryptsetup_210_release_notes}.

Apart from LUKS and LUKS2 formats, `cryptsetup` supports mounting volumes encrypted by other disk encryption utilities. The supported options are volumes formatted by Microsoft Windows BitLocker \cite{vojta_dp, csetup_man} and VeraCrypt (or TrueCrypt) \cite{csetup_man, veracrypt, tcrypt}. It only supports reading the metadata and mounting the device for these formats. Changing the metadata (like adding or removing a passphrase) is not supported because other authors maintain the formats, and `cryptsetup` could introduce incompatible changes or damage the volume. In the case of BitLocker, an official format specification is not available. Therefore the support is only experimental, and any changes to the header would be hazardous.

# Linux Unified Key Setup version 2 on-disk format

\input{figures/luks2_hdr.tex}

We have focused the effort on fuzzing LUKS2 volumes and will describe this format in detail. The LUKS2 header starts right at the beginning of the device. The first sector (512 bytes) contains the first copy of the binary header, followed by seven empty sectors amounting to eight sectors or 4KiB. The empty sectors allow future extension and ensure atomic write of the header on disks with 4KiB sector size. Therefore the header can be written atomically on disks with both sector sizes (512 bytes and 4KiB). ASCII encoded JSON metadata follows the binary header. The size of the JSON area is variable and specified in the binary header (the `hdr_size` field specifies the size of the JSON area plus the binary area). Supported sizes in KiB are 12, 28, 60, 124, 252, 508, 1020, 2044 and 4092. The second copy of the binary header and JSON metadata starts right after the end of the first JSON area. Therefore the possible offsets from the start of the device (in KiB) for the second binary header are 16, 32, 64, 128, 256, 512, 1024, 2048 and 4096. The second header is located at least 16KiB from the start of the device making accidental overwrite less likely. The keyslots area begins after the secondary header \cite{luks2}. The layout of the headers is shown in Figure-\ref{fig:luks2hdr}.

The binary header structure is described in Figure-\ref{fig:luks2hdr_struct}. The primary header contains a magic value that differs from the secondary one (specified by the constants `LUKS2_MAGIC_1ST` and `LUKS2_MAGIC_2ND`). Next is the `version` field, which is always 2 for LUKS2. The `hdr_size` specifies the size of the JSON area plus 4KiB for the binary header. The size of the primary header must be equal to the size of the secondary header. The `seqid` field is used for header versioning. It is increased after every header update, and during header repair, a newer header (i.e. with a higher `seqid`) is automatically chosen. The `label` and `subsystem` fields can contain arbitrary, at most 48 characters long, user-specified volume descriptions. The `csum_alg` field contains a string name of the checksum algorithm used for accidental header damage detection (SHA-256 is used by default). The whole binary header and JSON area are processed by the checksum algorithm specified by `csum_alg`, and the result is stored in the `csum` field. The `csum` field is set to zeroes during the checksum calculation. The `salt` field contains completely random data for every header copy to prevent deduplication of the primary and secondary headers (on storage configurations that support it). The salt is generated during formatting and regenerated only after header repair. A universally unique identifier (UUID) \cite{uuid} is specified in the `uuid` field. Finally, the `hdr_offset` field specifies the exact offset of the header on the physical device \cite{luks2}.

The JSON area is located after the binary header. The entire header (including the JSON area) is repeated twice to allow repair in case of corruption. The keyslots area, used for storing binary cryptographic material associated with the keyslots, follows the secondary header. The binary structures stored in the keyslots area depend on the specific keyslot type that references them \cite{luks2}.

\input{figures/luks2_hdr_struct.tex}

The JSON area contains a top-level JSON object with five mandatory sub-objects: **config**, **keyslots**, **digests**, **segments** and **tokens**. Their relationship is illustrated on Figure-\ref{fig:luks2schema}. Except for the config, every object contains sub-objects indexed by an integer converted to a string. Because of a limitation of JSON format, which does not support 64-bit integers, whenever a 64-bit integer is needed, the LUKS2 format converts it to a string (referred to as `string-uint64`).

\input{figures/luks2_objects.tex}

The **config** object contains properties that apply to the whole encrypted device. The properties include the size of the JSON area (which must correspond to the `hdr_size` minus 4KiB), size of the keyslots area, flags and requirements. Flags array specifies various `dm-crypt` options for activating the device, like allowing discards or integrity journal. Requirements array specifies which features must be supported by the `cryptsetup` utility implementation. If the used version of the utility does not support any of the specified requirements, it must not modify or activate the volume \cite{luks2}.

The **keyslots** object describes how is the volume key encrypted and where is it stored. Every object contains a type of the keyslot, size of the wrapped key, priority and an area object. The wrapped key location within the keyslots is described using the area object. It specifies the encrypted blob's offset and size, the algorithm used for key wrapping, and the key size after decryption. Additionally, the _luks2_ keyslot type can also define the used KDF, its parameters and the anti-forensic splitter. It allows using different KDFs for different keyslots (as seen in Listing-\ref{lst:json_header}) and easily extending support for new KDFs in the future \cite{luks2}.

The **segments** object describes encrypted user data sections in the data area, spanning from the keyslots section to the volume's end. It specifies the offset from the start of the device and the size of the segment. The segment type can be _linear_ or _crypt_. Linear means unencrypted and is used only during re-encryption. The _crypt_ type specifies the segment encryption algorithm, sector size, optional integrity protection parameters and additional flags. There is only a single _crypt_ segment covering the whole data area in most cases.

The **digests** object is used for verifying that the wrapped key (stored in the keyslot) was correctly unwrapped. It specifies the type of the digest, the associated keyslots and segments, the salt used for digest calculation and the correct digest result. The _pbkdf2_ digest type also specifies the parameters for the KDF used to derive the digest. Every keyslot must have an associated digest to confirm that a correct key was obtained after decryption. If no segment is associated with the digest, the keyslot is called _unbound_ \cite{luks2}. This way, arbitrary key material can be stored in the LUKS2 header (e.g. by a token that uses the wrapped key to authenticate against a server and obtain a passphrase).

Finally, the **tokens** object contains metadata used by the `cryptsetup` utility, plugin, or other application to obtain a passphrase from an arbitrary source (e.g., a smartcard or remote server). The only mandatory fields are the token type and a list of associated keyslots the passphrase obtained by the token can unlock. The token implementation can add any additional fields. The `cryptsetup` utility has built-in support only for the `luks2-keyring` token type. An example JSON metadata produced by `cryptsetup` version 2.4.3 with an external `systemd-tpm2` \cite{cryptenroll} token plugin is shown in Listing-\ref{lst:json_header}.

\input{figures/luks2_json.tex}
